require 'yaml'
require 'nokogiri'
require 'execjs'
require 'capybara/poltergeist'
require_relative 'sir/capybara_ext'
require 'pp'

Capybara.register_driver :poltergeist do |app|
  options = { timeout: 180,
              js_errors: false,
              phantomjs_options: ['--ignore-ssl-errors=yes'],
              window_size: [1680, 1050] }
  Capybara::Poltergeist::Driver.new(app, options)
end
Capybara.default_driver = :poltergeist

module Sir
  class << self
    attr_accessor :state
  end
end

require_relative 'sir/version'
require_relative 'sir/parser'
require_relative 'sir/wrapper'

module Sir
  def self.run!(path, initial_state = {})
    parser = Sir::Parser.new(path, initial_state)
    result = parser.run
    destroy_session parser.wrapper.session rescue nil
    result
  end

  def self.destroy_session(session)
    session.driver.quit
  end
end
